const logger = require('komodo-sdk/logger');
const commands = require('../command-group');

const cmds = [];
for (let [key, value] of Object.entries(commands)) {
    if (value.indexOf('_') !== 0) cmds.push(key.toUpperCase());
}
cmds.sort();

const cmds2 = [];
let cmdOnAGroup = [];
let lastKeyword;
cmds.forEach((item) => {
    if (lastKeyword && lastKeyword[0] !== item[0]) {
        cmds2.push(cmdOnAGroup.join(', '));
        cmdOnAGroup = [];
    }

    cmdOnAGroup.push(item);
    lastKeyword = item;
});

cmds2.push(cmdOnAGroup.join(', '));

// const msg = 'Perintah tersedia: ' + cmds.join(', ') + '.'
const msg = 'Perintah tersedia:\n\n' + cmds2.join(',\n\n');

logger.verbose('Help return message constructed', { count: cmds.length, chars: msg.length, lines: msg.split(/\r\n|\r|\n/).length });

module.exports = function(cb) {
    
    const responseParams = {
        body: msg
    }

    cb(null, null, responseParams);
}

